(* EPITA SPE 2009/2010       *)
(* Partiel 1 - Décembre 2009 *)
(* question 08               *)

module type S =
sig
  type t
  val zero      : t
  val succ      : t -> t
  val pred      : t -> t
  val add       : t -> t -> t
  val canon     : t -> t
  val equal     : t -> t -> bool
  val to_string : t -> string
end

module Peano : S =
struct
  type t = Zero | Succ of t | Pred of t
  let zero = Zero
  let succ i = Succ i
  let pred i = Pred i

  let rec add _ _ = (* FIX ME *) assert false

  let rec canon _ = (* FIX ME *) assert false

  let equal _ _   = (* FIX ME *) assert false

  let rec to_string = function
      Zero -> "0"
    | Succ n -> "Succ(" ^ (to_string n) ^ ")"
    | Pred n -> "Pred(" ^ (to_string n) ^ ")"
end
